/*----------------------------------------------------------------
 * game.c - hlavni funkce hry
 *----------------------------------------------------------------
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <allegro.h>
#include "criterr.h"       /* prototype for `critical_error' */
#include "variable.h"
#include "sound.h"
#include "time.h"
#include "init.h"
#include "comix.h"
#include "texts.h"
#include "menu.h"
#include "game.h"

int old_ground_time = 0;
int old_roof_time = 0;
int quit_flag = 0;	// kdyz == 1 tak quit
					// kdyz == 2 zabit
int bang;	// indikuje strelu
long bang_time = 0;
long finish_time = 0;	// cas, kdy ma skoncit
long duel_time = 0;	//time na duel

int write_system_info ()
{

#ifdef TO_VIDEO
    acquire_bitmap(game_screen);
#endif


if (gfx_capabilities & GFX_HW_VRAM_BLIT)
  textout(game_screen, font, "Video Blit: hardware accelerated", 0, SCREEN_H -
 20, makecol(255, 255, 255));
else
  textout(game_screen, font, "Video Blit: software", 0, SCREEN_H - 20,
 makecol(255, 255, 255));

if (gfx_capabilities & GFX_HW_VRAM_BLIT_MASKED)
  textout(game_screen, font, "Video Masked Blit: hardware accelerated", 0,
 SCREEN_H - 30, makecol(255, 255, 255));
else
  textout(game_screen, font, "Video Masked Blit: software", 0, SCREEN_H - 30,
 makecol(255, 255, 255));

if (gfx_capabilities & GFX_HW_MEM_BLIT)
  textout(game_screen, font, "Memory Blit: hardware accelerated", 0, SCREEN_H -
 40, makecol(255, 255, 255));
else
  textout(game_screen, font, "Memory Blit: software", 0, SCREEN_H - 40,
 makecol(255, 255, 255));

if (gfx_capabilities & GFX_HW_MEM_BLIT_MASKED)
  textout(game_screen, font, "Memory Masked Blit: hardware accelerated", 0,
 SCREEN_H - 50, makecol(255, 255, 255));
else
  textout(game_screen, font, "Memory Masked Blit: software", 0, SCREEN_H - 50,
 makecol(255, 255, 255));


#ifdef TO_VIDEO
    release_bitmap(game_screen);
#endif


  return 0;
}






//***************************************************
//     write_info
//***************************************************



int write_info()
{
	int i;

#ifdef TO_VIDEO
    acquire_bitmap(game_screen);
#endif

  //textprintf(game_screen, font, 0, 0, makecol(255, 255, 255),"NABOJU: %d  ZASTRELENYCH: %d", celkem_naboju, pocet_zabitych);
  //textprintf(game_screen, font, 0, 12, makecol(255, 255, 255),"ZIVOTU: %d", pocet_zivotu);
#ifdef DEBUG_VERSION
  textprintf(game_screen, font, 0, 50, makecol(255, 255, 255),"XY: %d, %d", mouse_x, mouse_y);
#endif
  //textprintf(game_screen, font, 0, 36, makecol(255, 255, 255),"S C O R E: %d", score);

  //pocet zivotu
  for (i=0; i<pocet_zivotu; i++)
  {
	masked_blit(bstar1, game_screen, 0, 0, 560-40*i, 0, 80, 78);
  }

	//print_string("SCORE", 10, 10);
	//print_num_dolar(score, 65, 5);
	//print_string("SCORE", 10, 30);
	//print_num_dolar(score, 65, 25);

	print_string("LEVEL", 10, 10);
	print_num(level, 65, 5);
	print_string("SCORE", 110, 10);
	print_num_dolar(score, 165, 5);


#ifdef TO_VIDEO
    release_bitmap(game_screen);
#endif

	return 0;
}









//***************************************************
//     pohni_objekty
//***************************************************



int pohni_objekty()
{
	int i, j, dvere;

	for (i=0; i<3; i++)
	{
		// test zda existuje, kdyz ne, zkusi vytvorit
		if (small_object[i].draw != 0)
		{
			//zjisteni, zda jiz pretekl cas
			if (small_object[i].last_time == 0)
				small_object[i].last_time = cas;
			// FIXME: tu je to nedokonale kdyz cas preskoci nekolikrat!
			if (small_object[i].last_time < cas - small_object[i].delay)
			{
				//small_object[i].last_time += small_object[i].delay;
				small_object[i].last_time = cas;
				// pohyb
				small_object[i].tik++;
				// FIXME: test, kdyz tick pretekl

				if ((small_object[i].mode == 0) &&
					(object[small_object[i].animation].tick[small_object[i].tik] == 2)
					&& (small_object[i].tik < small_object[i].end_tick))
				{
					// byls zasazen
					if (sound_volume)
						play_sample(object[small_object[i].animation].s_shot,
							(int)(VOL_SHOT*(sound_volume/100.0)), 127 - 50 + i*50, 1000, 0);
					//FIXME: mozna co tak nahodne cislo?
					for (i=0; i<MAX_POCET_DER; i++)
					{
						if (!dira[i].visible)
						{
							dira[i].X = rand()%550 - 50;
							dira[i].Y = rand()%340 - 50;
							dira[i].visible = 1;
							dira[i].old_time = cas;
							break;
						}
					}
					if (!life_cheat)	//CHEAT
						pocet_hitu = pocet_hitu + obtiznost + 1;
					if (pocet_hitu > 2)
					{
						pocet_hitu = 0;
						pocet_zivotu--;
						bang = 1;
					}
				}

				if ((small_object[i].mode == 0) &&
					(small_object[i].tik == small_object[i].end_tick))
				{
					small_object[i].draw = 0;
					if (small_object[i].type == 0)
						score += object[small_object[i].animation].score;
				}

				if ((small_object[i].mode == 1) &&
					(small_object[i].type == 2) &&
					(small_object[i].tik == 5))
				{
					init_small(i, object[small_object[i].animation].next_name);
					small_object[i].tik = 3;
				}

				if ((small_object[i].mode == 1) &&
					(small_object[i].tik == 8))
				{
					small_object[i].draw = 0;
				}


			}


		} else {
		//FIXME: random vytvoreni objektu pro index i
			if ((small_object[0].draw + small_object[1].draw + small_object[2].draw <
 max_doors_open) &&
				(rand() % 1000 < refresh_door) &&
				(bang == 0))
			{
				//dvere = rand() % 500 < (level*level + 1) * 5
				//dvere = rand() % 100;
				dvere = rand() % max_pravdepodobnost;
				for (j=0; j < object_count; j++)
				{
					if (dvere < object[j].vaha)
					{
						// vytvoreni
						init_small(i, j);
						break;
					}
				}
			}

		}

	}

	//diry
	for (i=0; i<MAX_POCET_DER; i++)
		if ((dira[i].visible) && (dira[i].old_time + DIRA_DELAY < cas))
			dira[i].visible = 0;


	return 0;
}








//***************************************************
//     duel
//***************************************************



int duel_pohni_objekty()
{
	int i;

	for (i=0; i<3; i++)
	{
		// test zda existuje, kdyz ne, zkusi vytvorit
		if (small_object[i].draw != 0)
		{
			//zjisteni, zda jiz pretekl cas
			if (small_object[i].last_time == 0)
				small_object[i].last_time = cas;
			// FIXME: tu je to nedokonale kdyz cas preskoci nekolikrat!
			if ((small_object[i].last_time < cas - small_object[i].delay)
 &&(small_object[i].tik < 4) && (small_object[i].mode==0) && (rand()%100<70))
				small_object[i].last_time = cas;
			if (small_object[i].last_time < cas - small_object[i].delay)
			{
				//small_object[i].last_time += small_object[i].delay;
				small_object[i].last_time = cas;
				// pohyb
				small_object[i].tik++;
				// FIXME: test, kdyz tick pretekl

				if ((small_object[i].mode == 0) &&
					(object[small_object[i].animation].tick[small_object[i].tik] == 2)
					&& (small_object[i].tik < small_object[i].end_tick))
				{
					// byls zasazen
					if (sound_volume)
						play_sample(object[small_object[i].animation].s_shot,
								(int)(VOL_SHOT*(sound_volume/100.0)), 127 - 50 + i*50, 1000, 0);
					//FIXME: mozna co tak nahodne cislo?
					for (i=0; i<MAX_POCET_DER; i++)
					{
						if (!dira[i].visible)
						{
							dira[i].X = rand()%550 - 50;
							dira[i].Y = rand()%340 - 50;
							dira[i].visible = 1;
							dira[i].old_time = cas;
							break;
						}
					}
					if (!life_cheat)	//CHEAT
						pocet_hitu = pocet_hitu + obtiznost + 1;
					if (pocet_hitu > 2)
					{
						pocet_hitu = 0;
						pocet_zivotu--;
						bang = 1;
					}
				}

				if ((small_object[i].mode == 0) &&
					(small_object[i].tik == small_object[i].end_tick))
				{
					//small_object[i].draw = 0;
					small_object[i].tik--;
					//if (small_object[i].type == 0)
					//	score += object[small_object[i].animation].score;
				}

				if ((small_object[i].mode == 1) &&
					(small_object[i].type == 2) &&
					(small_object[i].tik == 5))
				{
					init_small(i, object[small_object[i].animation].next_name);
					small_object[i].tik = 3;
				}

				if ((small_object[i].mode == 1) &&
					(small_object[i].tik == 8))
				{
					small_object[i].tik = 7;
				}


			}


		}

	}

	//diry
	for (i=0; i<MAX_POCET_DER; i++)
		if ((dira[i].visible) && (dira[i].old_time + DIRA_DELAY < cas))
			dira[i].visible = 0;


	return 0;
}







//***************************************************
//     draw_game_screen
//***************************************************




int draw_game_screen()
{
	int i;

    //animate_anim_object(object[0].anim_object);

#ifdef TO_VIDEO
    acquire_bitmap(game_screen2);
	acquire_bitmap(game_screen);
#endif
    blit(game_screen2, game_screen, 0, 0, 0, 0, 640, 480);
#ifdef TO_VIDEO
	release_bitmap(game_screen2);
	release_bitmap(game_screen);
#endif

 	if (level_mode == 1)
		duel_pohni_objekty();
	else
		pohni_objekty();


	//decorations
	for (i=0; i<decoration_count; i++)
	{
		if (decoration[i].mode)
		{
			fr_draw_anim_object(decoration[i].anim_object, decoration[i].X,
 decoration[i].Y, 1, 0);
			if ((decoration[i].type == 2) && (cas > decoration[i].old_time + 40))
				decoration[i].mode = 0;
		}
		else
			fr_draw_anim_object(decoration[i].anim_object, decoration[i].X,
 decoration[i].Y, 0, 0);
	}
	//draw_center_top(object[small_object[i].animation].anim_object, small_object[i].X, small_object[i].Y, 3, 0);



	// vykresli objekty
	for (i=0; i<3; i++)
	{
		if (small_object[i].draw)
		{
			if (small_object[i].mode == 0)
			{
				draw_center_top(object[small_object[i].animation].anim_object,
				small_object[i].X, small_object[i].Y,
				object[small_object[i].animation].tick[small_object[i].tik],
				0);

			} else {
				if (small_object[i].tik < 2)
					draw_center_top(object[small_object[i].animation].anim_object,
 small_object[i].X, small_object[i].Y, 3, 0);
				else
					draw_center_top(object[small_object[i].animation].anim_object,
 small_object[i].X, small_object[i].Y, 4, 0);
			}


			// vykresleni dveri - otevirani
			if ((small_object[i].mode == 0) && (small_object[i].tik<4))
				fr_draw_anim_object(dvere[i].anim_object, dvere[i].X, dvere[i].Y, 0,
 small_object[i].tik);
			else
				if ((small_object[i].mode == 0) && (small_object[i].tik <
 small_object[i].end_tick - 1))
					fr_draw_anim_object(dvere[i].anim_object, dvere[i].X, dvere[i].Y, 0, 3);


			// vykresleni dveri - zavirani

			if ((small_object[i].mode == 0) &&
				(small_object[i].tik > small_object[i].end_tick - 2))
				fr_draw_anim_object(dvere[i].anim_object, dvere[i].X, dvere[i].Y, 0,
 small_object[i].end_tick - small_object[i].tik);
			if (small_object[i].mode == 1)
			{
				if (small_object[i].tik > 5)
					fr_draw_anim_object(dvere[i].anim_object, dvere[i].X, dvere[i].Y, 0, 8 -
 small_object[i].tik);
				else
					fr_draw_anim_object(dvere[i].anim_object, dvere[i].X, dvere[i].Y, 0, 3);
			}


		} else {
			fr_draw_anim_object(dvere[i].anim_object, dvere[i].X, dvere[i].Y, 0, 0);
		}
	}




	//KOLT
	kolt_X = (mouse_x / 90) ;
	if (kolt_X > 6)
		kolt_X = 6;

	if (shot_show)
	{
		// je videt strelba
		if (shot_last_time + FIRE_SHOT_DELAY < cas)
			shot_show = 0;
		draw_center_bottom(kolt_anim, kolt[kolt_X].X + (int)((mouse_x % 90 - 45)/1.4), 480 + (mouse_y / 10), kolt_X , 1);
		draw_center_bottom(nabojnik_anim, 560, 460, pocet_naboju, 1);
	} else {
		if (reload_show)
		{
			draw_center_bottom(kolt_anim, kolt[kolt_X].X + (int)((mouse_x % 90 - 45)/1.4), 480 + (mouse_y / 10), kolt_X , 0);
			if (reload_last_time + RELOAD_DELAY < cas)
				reload_show = 0;
			if (obtiznost == 2)
				draw_center_bottom(nabojnik_anim, 560, 460, pocet_naboju - 1, 1);
			else
				draw_center_bottom(nabojnik_anim, 560, 460, pocet_naboju, 1);

		} else {
			draw_center_bottom(kolt_anim, kolt[kolt_X].X + (int)((mouse_x % 90 - 45)/1.4), 480 + (mouse_y / 10), kolt_X , 0);
			draw_center_bottom(nabojnik_anim, 560, 460, pocet_naboju, 0);
		}
	}

	write_info();

	// ikona
#ifdef TO_VIDEO
	acquire_bitmap(game_screen);
#endif
    //masked_blit(bhead[pocet_hitu/3], game_screen, 0, 0, 0, 376, 113, 104);
	if (life_cheat)
		masked_blit(bcheat_life, game_screen, 0, 0, 0, 376, 113, 104);
	else
		masked_blit(bhead[pocet_hitu], game_screen, 0, 0, 0, 376, 113, 104);

	//CHEAT
	if (kill_civil_cheat)
		masked_blit(bcheat_civil, game_screen, 0, 0, 460, 434, 40, 46);



	//if (bang)
	//	masked_blit(bf, game_screen, 0, 0, 0, 60, 640, 360);

	//if (life_cheat) //CHEAT
	//	masked_blit(bbang, game_screen, 0, 0, 0, 60, 640, 360);


	for (i=0; i<MAX_POCET_DER; i++)
		if (dira[i].visible)
		{
			masked_blit(bmhole, game_screen, 0, 0, dira[i].X, dira[i].Y, 160, 160);
		}

		if (pocet_zabitych != max_level_bandit)
		{
			vline(game_screen, 633, 50+400*pocet_zabitych/max_level_bandit, 450,
 makecol(180,180,180));
			vline(game_screen, 634, 50+400*pocet_zabitych/max_level_bandit, 450,
 makecol(200,200,200));
			vline(game_screen, 635, 50+400*pocet_zabitych/max_level_bandit, 450,
 makecol(200,200,200));
			vline(game_screen, 636, 50+400*pocet_zabitych/max_level_bandit, 450,
 makecol(180,180,180));
		}
		//pocet_zabitych >= max_level_bandit
#ifdef TO_VIDEO
	release_bitmap(game_screen);
#endif



	//NABOJNIK
//	draw_center_bottom(nabojnik_anim, 500, 440, pocet_naboju, 0);



#ifdef DEBUG_VERSION
	write_system_info();
#endif
	return 0;
}








//***************************************************
//     DUEL
//***************************************************




int duel_draw_game_screen()
{
	int i;

#ifdef TO_VIDEO
    acquire_bitmap(game_screen2);
	acquire_bitmap(game_screen);
#endif
    blit(game_screen2, game_screen, 0, 0, 0, 0, 640, 480);
#ifdef TO_VIDEO
	release_bitmap(game_screen2);
	release_bitmap(game_screen);
#endif


	duel_pohni_objekty();




	// vykresli objekty
	for (i=0; i<3; i++)
	{
		if (small_object[i].draw)
		{
			if (small_object[i].mode == 0)
			{
				draw_center_top(object[small_object[i].animation].anim_object,
				small_object[i].X, small_object[i].Y,
				object[small_object[i].animation].tick[small_object[i].tik],
				0);

			} else {
				if (small_object[i].tik < 2)
					draw_center_top(object[small_object[i].animation].anim_object,
 small_object[i].X, small_object[i].Y, 3, 0);
				else
					draw_center_top(object[small_object[i].animation].anim_object,
 small_object[i].X, small_object[i].Y, 4, 0);
			}
		}

			// vykresleni dveri - zavirani

	}




	//KOLT
	kolt_X = (mouse_x / 90) ;
	if (kolt_X > 6)
		kolt_X = 6;

	if (shot_show)
	{
		// je videt strelba
		if (shot_last_time + FIRE_SHOT_DELAY < cas)
			shot_show = 0;
		draw_center_bottom(kolt_anim, kolt[kolt_X].X + (int)((mouse_x % 90 - 45)/1.4), 480 + (mouse_y / 10), kolt_X , 1);
		draw_center_bottom(nabojnik_anim, 560, 460, pocet_naboju, 1);
	} else {
		if (reload_show)
		{
			draw_center_bottom(kolt_anim, kolt[kolt_X].X + (int)((mouse_x % 90 - 45)/1.4), 480 + (mouse_y / 10), kolt_X , 0);
			if (reload_last_time + RELOAD_DELAY < cas)
				reload_show = 0;
			if (obtiznost == 2)
				draw_center_bottom(nabojnik_anim, 560, 460, pocet_naboju - 1, 1);
			else
				draw_center_bottom(nabojnik_anim, 560, 460, pocet_naboju, 1);

		} else {
			draw_center_bottom(kolt_anim, kolt[kolt_X].X + (int)((mouse_x % 90 - 45)/1.4), 480 + (mouse_y / 10), kolt_X , 0);
			draw_center_bottom(nabojnik_anim, 560, 460, pocet_naboju, 0);
		}
	}

	write_info();

	// ikona
#ifdef TO_VIDEO
	acquire_bitmap(game_screen);
#endif

	if (life_cheat)
		masked_blit(bcheat_life, game_screen, 0, 0, 0, 376, 113, 104);
	else
		masked_blit(bhead[pocet_hitu], game_screen, 0, 0, 0, 376, 113, 104);

	//CHEAT
	if (kill_civil_cheat)
		masked_blit(bcheat_civil, game_screen, 0, 0, 460, 434, 40, 46);


	for (i=0; i<MAX_POCET_DER; i++)
		if (dira[i].visible)
		{
			masked_blit(bmhole, game_screen, 0, 0, dira[i].X, dira[i].Y, 160, 160);
		}
#ifdef TO_VIDEO
	release_bitmap(game_screen);
#endif


#ifdef DEBUG_VERSION
	write_system_info();
#endif
	return 0;
}






//***************************************************
//     decoration_shot
//***************************************************



int decoration_shot(int X, int Y)
{
	// vrati jestli byla terfena dekorace
	int decor = -1;
	int i;

	for (i=0; i<decoration_count; i++)
	{
		if ((Y>decoration[i].Y-8) &&
			(Y<decoration[i].Y+decoration[i].anim_object->frame[0].height) &&
			(X>decoration[i].X-8) &&
			(X<decoration[i].X+decoration[i].anim_object->frame[0].width))
		{
			decor = i;
			break;
		}
	}

	// kdyz streleno, neco udelej
	if (decor != -1)
	{
		//zniceni
		if (decoration[decor].mode == 0)
		{
			if ((decoration[decor].s_destroy) && (sound_volume))
				play_sample(decoration[decor].s_destroy, (int)(VOL_DESTROY*(sound_volume/100.0)), 127 + (decoration[decor].X-320)/2, 1000, 0);
			decoration[decor].mode = 1;
			decoration[decor].old_time = cas;

		}
	}

	return decor+1;
}



int door_shot(int X, int Y)
{
	// vrati jestli byly terfeny dvere
	int dvere = -1;

	if ((Y>128) && (Y<315))
	{

		if ((X>32) && (X<128))
			dvere = 0;

		if ((X>252) && (X<350))
			dvere = 1;

		if ((X>474) && (X<572))
			dvere = 2;
	}
	return dvere;
}


int no_shot(int X, int Y)
{
	// vrati jestli byly terfeny dvere
	int dvere = 0;

	if ((Y>97-12) && (Y<315+8))
	{

		if ((X>22-14) && (X<152+16))
			dvere = 1;

		if ((X>243-14) && (X<373+16))
			dvere = 2;

		if ((X>465-14) && (X<595+16))
			dvere = 3;
	}
	return dvere;
}



int strela(int index)
{
	if ((small_object[index].draw) & (small_object[index].mode == 0))
	{
		// ano, byl nekdo zasazen
		if (sound_volume)
			play_sample(object[small_object[index].animation].s_dead, (int)(VOL_DEAD*(sound_volume/100.0)), 127 - 50 + index*50, 1000, 0);

//		if ((small_object[index].tik >= small_object[index].shot_tick)
		if ((object[small_object[index].animation].tick[small_object[index].tik] > 0)
			//&& (small_object[index].tik < small_object[index].end_tick - 2)
			&& (small_object[index].type))
		{
			// byl zasazen
			score += (((obtiznost+1)/2)*object[small_object[index].animation].score);
			pocet_zabitych++;

			//FIXME: zjisteni, jaky je mod hrace, kdyz vetsi nez 1,
			//tak skok opet na tick
			small_object[index].tik = 0;
			small_object[index].last_time = cas;
			small_object[index].mode = 1;
		} else {
			//if (small_object[index].tik < small_object[index].end_tick - 2)
			//{
				// byl zasazen, ale nemel byt

				if ((!life_cheat) && (!kill_civil_cheat))	//CHEAT
				{
					pocet_hitu = 0;
					pocet_zivotu--;
					bang = 1;
				}
				if (score<0)
					score = 0;
				small_object[index].tik = 0;
				small_object[index].last_time = cas;
				small_object[index].mode = 1;
			//}
		}

	}
	return index;
}





















//***************************************************
//     main_game
//***************************************************





int main_game()
{
    long old_cas = 0;
 	int fps = 0, fps_count = 0;
	int i;
	pos_X = 0;
    pos_Y = 0;
	quit_flag = 0;
	//pocet_zabitych = 0;

	quit_flag = 0;
	bang = 0;	// indikuje strelu
	bang_time = 0;
	finish_time = 0;	// cas, kdy ma skoncit
	duel_time = 0;	//time na duel

	// prehrani pocatecniho komixu, je-li
	if (strcmp(komix_start,"")!=0)
		comix_play(komix_start);

	set_mouse_range(6, 8, 640 - 20, 340);

	if (level_mode == 1)
	{
		init_small(0, 0);
		init_small(1, 1);
		init_small(2, 2);
		duel_time = cas;
	}


	//{

		do {
            tovy_timer();
            show_mouse(NULL);




			// MYS
			if ((mouse_b & 1) && (shot_last_time + SHOT_DELAY < cas)
				 && (reload_last_time + RELOAD_DELAY + 12 < cas))
			{
				// leve tlacitko
				shot_last_time = cas;

				// odecteni naboju
				if (pocet_naboju>0)
				{
					// STRELA
					if (sound_volume)
						play_sample(s_shot, (int)(VOL_SHOT*(sound_volume/100.0)), 127 - 16 + (mouse_x / 20), 1000, 0);

					shot_show = 1;
					pocet_naboju--;
					strela(door_shot(mouse_x, mouse_y));
					decoration_shot(mouse_x, mouse_y);

					if (
						!(no_shot(mouse_x, mouse_y)) && (mouse_y<315))
					{

						//vykresli diru
						//FIXME: nahodne
	if (level_mode == 0)
	{
#ifdef TO_VIDEO
    acquire_bitmap(game_screen2);
#endif
		set_multiply_blender(0,0,0,190);
		draw_trans_sprite(game_screen2, bhole[rand()%4], mouse_x, mouse_y);
#ifdef TO_VIDEO
	release_bitmap(game_screen2);
#endif
	}
					}
				}

			}


			if ((mouse_b & 2) && (!shot_show) && (reload_last_time + RELOAD_DELAY < cas))

			{
				if (obtiznost == 2)
				{
					if (pocet_naboju < max_pocet_naboju)
						if (celkem_naboju > 0)
						{
							if (sound_volume)
								play_sample(s_reload, (int)(VOL_RELOAD*(sound_volume/100.0)), 127, 1000, 0);
							reload_last_time = cas;
							celkem_naboju--;
							pocet_naboju++;
							reload_show = 1;
						}
				}

			if ((obtiznost == 1) && (pocet_naboju<max_pocet_naboju))
			{
				if (sound_volume)
					play_sample(s_reload, (int)(VOL_RELOAD*(sound_volume/100.0)), 127, 1000, 0);
				reload_last_time = cas;
				reload_show = 1;
				if (max_pocet_naboju - pocet_naboju > celkem_naboju)
				{
					pocet_naboju += celkem_naboju;
					celkem_naboju = 0;
				} else {
					celkem_naboju -= (max_pocet_naboju - pocet_naboju);
					pocet_naboju = max_pocet_naboju;
				}
			}
		}

		//samonabojeni
		if ((pocet_naboju==0) && (obtiznost == 0) && (celkem_naboju>0))
		{
			if (sound_volume)
				play_sample(s_reload, (int)(VOL_RELOAD*(sound_volume/100.0)), 127, 1000, 0);
			reload_last_time = cas;
			reload_show = 1;
			if (max_pocet_naboju - pocet_naboju > celkem_naboju)
			{
				pocet_naboju += celkem_naboju;
				celkem_naboju = 0;
			} else {
				celkem_naboju -= (max_pocet_naboju - pocet_naboju);
				pocet_naboju = max_pocet_naboju;
			}
		}




			if (level_mode == 1)
				duel_draw_game_screen();
			else
				draw_game_screen();

            //world_move();

            // zjisteni fps
            fps_count++;
            if (fps_count == 50)
            {
            fps = (CLOCKS_PER_SEC * 50 / (clock() - old_cas + 1));
            //FIXME: co je spatne?! ze nemohu dat o_time = cas
            old_cas = (long)(clock());
            fps_count = 0;
            }


#ifdef TO_VIDEO
	acquire_bitmap(game_screen);
#endif

#ifdef DEBUG_VERSION

            textprintf_centre(game_screen, font, 500, 426, makecol(255, 255, 255),"time = %ld", cas);
            textprintf_centre(game_screen, font, 500, 436, makecol(255, 255, 255),"fps = %ld", fps);
            textprintf_centre(game_screen, font, 500, 446, makecol(255, 255, 255),"fps_count = %d", fps_count);
#endif

#ifdef TO_VIDEO
    release_bitmap(game_screen);
#endif

#ifdef TO_VIDEO
	acquire_bitmap(game_screen);
#endif
			//acquire_bitmap(game_screen);
            show_mouse(game_screen);    // show cursor
#ifdef TO_VIDEO
    release_bitmap(game_screen);
#endif
			//release_bitmap(game_screen);
			//vsync();            /* Note: must acquire_screen before vsync! */

#ifdef TO_VIDEO
	acquire_screen();
    acquire_bitmap(game_screen);
#endif

			//if (full_redraw) {
				/* We don't actually need to do anything special here because
				 * we're redrawing the whole screen all the time anyway.
				 * Just clear the flag. */
			//	full_redraw = 0;
			//}

			//blit (game_screen, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
			vsync();
			blit(game_screen, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
#ifdef TO_VIDEO
	release_screen();
    release_bitmap(game_screen);
#endif

			// bbang!
			if ((bang==1) && (bang_time==0))
			{
				//tovy_delay(50);
				//bang = 0;
				//while (!(mouse_b && 1));
				//while (mouse_b && 1);
				for (i=0; i<3; i++)
				{
					if ((small_object[i].draw) &&
						(small_object[i].mode == 0))
					{
						small_object[i].tik = small_object[i].end_tick - 3;
						bang_time = cas;
					}
				}
			}
			if ((bang==1) && (bang_time + BANG_DELAY < cas))
			{
				//konec bangu
				bang = 0;
				bang_time = 0;
			}

			//release_bitmap(game_screen);

			if (key[KEY_N])
				celkem_naboju += 6;

			if (key[KEY_B])
				save_screen();

			if (key[KEY_ESC])
			{
				//menu_option(1);
				if (menu_yesno())
					break;
				set_mouse_sprite(mouse_shot);
				tovy_timer_wait();
			}



			//NOVY LEVEL
			if ((pocet_zabitych >= max_level_bandit)
				&& (finish_time == 0))
			{
				finish_time = cas;
				bang = 2;
			}

			if ((pocet_zivotu>0) &&
				((pocet_zabitych >= max_level_bandit)
				&& (finish_time + 270 < cas))
				|| ((duel_time + 750 < cas) && (level_mode == 1)))
			{
				// prehrani komixu konce levelu, je-li
				show_mouse(NULL);
				tovy_delay(20);
				if (strcmp(komix_finish,"")!=0)
					comix_play(komix_finish);
				destroy_level();
				load_level("levels.txt", next_level);
				// prehrani pocatecniho komixu, je-li
				if (strcmp(komix_start,"")!=0)
					comix_play(komix_start);
				bang = 0;
				bang_time = 0;
				finish_time = 0;
				quit_flag = 0;
				duel_time = 0;	//time na duel
				if (level_mode == 1)
				{
					init_small(0, 0);
					init_small(1, 1);
					init_small(2, 2);
					duel_time = cas;
				}
				show_mouse(game_screen);
			}

			if ((pocet_zivotu <= 0) && (finish_time==0) && (bang != 3))
			{
				bang = 3;
				finish_time = cas;
			}

			if ((pocet_zivotu <= 0) && (finish_time + 270 < cas))
				quit_flag = 2;



        } while (!(key[KEY_Q]) && !(quit_flag));    /* Loop until a key is pressed */

		if (key[KEY_Q])
            clear_keybuf();
		destroy_level();

		show_mouse(NULL);
		comix_play("gameover.cmx");
		//menu_topten(score);
		menu_topten(score);
		show_mouse(mouse_pointer);


	//}

	set_mouse_range(20, 20, 640 - 20, 480-20);


	return 0;
}
