/*----------------------------------------------------------------
 * sound.c - zvyky a hudba
 *----------------------------------------------------------------
 */

#include <allegro.h>

int music_volume, sound_volume, master_volume;
int music_on = 0;

SAMPLE *s_shot;
SAMPLE *s_bandit_shot;
SAMPLE *s_bandit_cry;
SAMPLE *s_reload;
SAMPLE *s_music = NULL;


int init_sound()
{

	if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, "") != 0)
	{
		allegro_message("Error initialising sound\n%s\n", allegro_error);
		exit(1);
	}

	s_shot = load_sample("data/sound/colt.wav");
	s_bandit_shot = load_sample("data/sound/b_colt.wav");
	s_bandit_cry = load_sample("data/sound/dead01.wav");
	s_reload = load_sample("data/sound/reload.wav");

	music_volume = 50;
	sound_volume = 70;
	master_volume = 100;

	return 0;
}



int destroy_sound()
{
	destroy_sample(s_shot);
	destroy_sample(s_bandit_shot);
	destroy_sample(s_bandit_cry);
	destroy_sample(s_reload);

	return 0;
}
